#! /usr/bin/python
# -*- coding: utf8 -*-
import cgitb;cgitb.enable()
import os
import cgi
import shutil

from imLib import Repository
from imLib import Category
from imLib import Page
from imLib import UserDB

teul = '''<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="Content-Type" content="text/html;charset=utf-8" />
	<title>Imwiki Installation - %s</title>
</head>
<body>
%s
</body>
</html>'''


def checkAndCreateRepository():
	# 퍼미션검사부터.. seed랑 imwiki폴더
	if not os.access('.', os.W_OK):
		return '퍼미션을 화인하세요.'
	if not os.access('seed', os.R_OK):
		return '퍼미션을 화인하세요.'
	Repository.createRepository()

def copySeedPages():
	globalPageList = ['RecentChanges', 'TitleIndex', 'FindPage']
	pageRepository = Repository.getPageRepository()
	cur, dirs, files = os.walk('seed').next()
	rootCategory  = Category.Category()
	globalCategory = Category.createCategoryByCategoryPath('Global')
	for fname in files:
		filePath = os.path.join(cur, fname)
		fp = file(filePath, 'rb')
		permission = fp.readline().strip()
		tags = fp.readline().strip()
		rawText = fp.read()
		fp.close()
		if fname in globalPageList:
			category = globalCategory
		else:
			category = rootCategory
		Page.createPage(category, fname, rawText, tags, permission)

def regAdminForm():
	formTeul = '''<strong>Admin Registration</strong>
<form name="regAdmin" method="post">
	<input type="hidden" name="step" value="2" />
	uid <input type="text" name="uid" />
	passwd <input type="password" name="passwd" />
	email <input type="text" name="email" />
	<input type="submit" value="submit" />
</form>'''
	return teul % ('step 2', formTeul)

def regAdmin(form):
	uid = form.getvalue('uid', '').strip()
	passwd = form.getvalue('passwd', '').strip()
	email = form.getvalue('email', '').strip()
	if uid and passwd:
		udb = UserDB.UserDB()
		udb.addUser(uid, passwd, email, 'admin')
		return True
	return False
	

if __name__ == '__main__':
	print 'Content-type: text/html\n'
	form = cgi.FieldStorage()
	step = form.getvalue('step', '1')
	init = form.getvalue('init', '')
	if init:
		Repository.removeRepository()
	if  step == '1':
		checkAndCreateRepository()
		copySeedPages()
		print regAdminForm()
	elif step == '2':
		if not regAdmin(form):
			print 'admin registration fail'
		print teul % ('Finished', 'Start your Imwiki')
